define("mod-util/0.3.0/Util-debug", ["jquery"], function(require, exports, module){
var Util = {};

Util.url = require("mod-util/0.3.0/src/url-debug");
Util.dataApi = require("mod-util/0.3.0/src/data-api-debug");
Util.tool = require("mod-util/0.3.0/src/tool-debug");
Util.platform = require("mod-util/0.3.0/src/platform-debug");
Util.style = require("mod-util/0.3.0/src/style-debug");
Util.regHandlebarsHelper = require("mod-util/0.3.0/src/handlebarsHelper-debug");
//Util.lcs = require('./src/lcs');
//Util.share = require('./src/share');
Util.inherits = function(ctor,superCtor,ignores){
    var proto = ctor.prototype,superProto = superCtor.prototype || superCtor;
    for(var p in superProto){
        if(superProto.hasOwnProperty(p)){
            if(ignores && Util.tool.indexOf(p,ignores) === -1) continue;

            if(p !== 'prototype'){
                proto[p] = superProto[p];
            }
        }

    }
}
module.exports = Util;
});
define("mod-util/0.3.0/src/url-debug", [], function(require, exports, module){
'use strict';
var tool = require("mod-util/0.3.0/src/tool-debug");
var setQuery=function(str, obj, isHash){
    var i, j,
        hash = (i = str.indexOf("#")) > -1 ? str.substring(i + 1) : "",
        query = (j = str.indexOf("?")) > -1 ? (i > j ? str.substring(j + 1, i) : str.substring(j+1) ): "";
    str = str.substring(0, (j >= 0 ? j : (i >= 0) ? i : str.length));
    hash = parseQuery(hash);
    query = parseQuery(query);
    for (var key in obj) {
        if (!obj.hasOwnProperty(key)) {
            continue;
        }
        if (isHash) {
            if(obj[key] == null || obj[key] == ''){
                try{
                    delete hash[key]
                }catch(ex){}
            }else
                hash[key] = obj[key];
        } else {
            if(obj[key] == null || obj[key] == ''){
                try{
                    delete query[key];
                }catch(ex){}
            }else
                query[key] = obj[key];
        }
    }
    query = obj2Str(query);
    hash = obj2Str(hash);
    return str + (query.length > 0 ? "?" + query : "") + (hash.length > 0 ? "#" + hash : "");

}
var parseQuery = function(query){
    if (tool.trim(query) == "") {
        return {};
    }
    var params = query.split("&"), len = params.length, i = 0, t, ret = {};
    for (; i < len; i++) {
        t = params[i].split("=");
        if (t.length == 2) {
            ret[t[0]] = t[1];
        }
    }
    return ret;
}
module.exports = {
    setQuery:setQuery,
    parseQuery:parseQuery
};
tool._.each(['hash','search'],function(item,_){
    var method = tool.ucFirst(item);
    module.exports['get'+method] = function(){
        var t = window.location[item].substring(1);
        return parseQuery(t);
    }
    module.exports['set'+method] = function(obj){
        var isHash = item === 'hash',
            str = window.location[item],
            ret = setQuery(str,obj,isHash);
        window.location[item] = ret;
        return ret;
    }
})

//helper
function obj2Str(obj, join) {
    var ret = [];
    for (var key in obj) {
        if (!obj.hasOwnProperty(key)) {
            continue;
        }
        ret.push(key + "=" + obj[key]);
    }
    return ret.join(join || "&");
}

});
define("mod-util/0.3.0/src/tool-debug", [], function(require, exports, module){
/**
 * Created by Harris on 14/12/25.
 */
    'use strict';
var AW = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
exports._ = require("mod-util/0.3.0/lib/underscore-debug");
var floor = Math.floor;
var loadJS = function (url, callback) {
    var script = document.createElement("script");
    script.type = "text/javascript";
    script.callback = typeof callback != "undefined" ?  callback : new Function();
    script[document.all ? "onreadystatechange" : "onload"] = function () {
        if (document.all && this.readyState != "loaded" && this.readyState != "complete") {return;}
        this.callback(this);
        this.callback = null;
        this[document.all ? "onreadystatechange" : "onload"] = null;
        this.parentNode.removeChild(this);
    };
    script.src = url;
    document.getElementsByTagName("head")[0].appendChild(script);
};
exports.loadJS = loadJS;
var indexOf = Array.prototype.indexOf ?
    function(arr, item) {
        return arr.indexOf(item)
    } :
    function(arr, item) {
        for (var i = 0, len = arr.length; i < len; i++) {
            if (arr[i] === item) {
                return i
            }
        }
        return -1
    };
exports.indexOf = indexOf;
var strToDate = function(str){
    str = makeString(str);
    var date = new Date(str.replace(/-/g,'/'));
    if((/Invalid/i).test(date)){
        date = new Date(null);
    }
    return date;
};
exports.strToDate = strToDate;
var strToTime = function(str){
    return strToDate(str).getTime();
};
exports.strToTime = strToTime;

var timeFixed = function(t){
    return t < 10 ? "0" + t : t+'';
};
exports.timeFixed = timeFixed;
var timeDiff = function(time1,time2){
    if(arguments.length === 1){
        time2 = time1;
        time1 = 0;
    }
    if(typeof time1 === 'string'){
        time1 = strToTime(time1);
    }
    if(typeof time2 === 'string'){
        time2 = strToTime(time2);
    }
    var diff = (time2 - time1) / 1000,
        dd = parseInt(diff / 60 / 60 / 24 , 10),
        hh = parseInt(diff / 60 / 60 % 24 , 10),
        mm = parseInt(diff / 60 % 60,10),
        ss = parseInt(diff % 60,10);
    return diff >= 0 ? {
        dd:timeFixed(dd),
        hh:timeFixed(hh),
        mm:timeFixed(mm),
        ss:timeFixed(ss)
    } : false;
};
exports.timeDiff = timeDiff;
var ucFirst = function (str) {
    return str.charAt(0).toUpperCase() + str.substring(1)
}
exports.ucFirst = ucFirst;
var random = function(min,max){
    if(arguments.length === 0){
        return 0;
    }
    if(arguments.length === 1){
        max = min;
        min = 0;
    }
    return min + Math.floor((max - min + 1) * Math.random());
};
exports.random = random;
var now = function(){
    return new Date().getTime();
};
exports.now = now;

var r2 = function(){
    var r = Math.random();
    if(r <= 0.5){
        return random(2,10);
    }else if(r > 0.5 && r <= 0.9){
        return random(11,50);
    }else{
        return random(51,300);
    }
}
exports.r2 = r2;
var numFix = function(num,len,fix,dot){
    if(arguments.length === 0){
        return '0';
    }else if(arguments.length == 1){
        fix = '0';
        len = 2;
    }else if(arguments.length == 2){
        if(typeof len === 'boolean'){
            fix = '0';
            dot = len;
            len = 2;
        }else if(typeof len === 'string'){
            fix = len;
            len = 2;
        }else{
            fix = '0';
        }
    }else if(arguments.length === 3 && typeof fix === 'boolean'){
        dot = fix;
        fix = '0'
    }
    if(dot){
        return Number(num).toFixed(len);
    }
    var _num_len = (num + '').length,ret = num + '';
    for(var i = _num_len;i<len;i++){
        ret = fix + '' + ret;
    }
    return ret;
};
exports.numFix = numFix;
var faceFilter = (function(){
    var regExp = /\[(.*?)\]/g;
    var allFaces = {
        '国旗': 'dc/flag_thumb',
        '走你': 'ed/zouni_thumb',
        '笑哈哈': '32/lxhwahaha_thumb',
        '江南style': '67/gangnamstyle_thumb',
        '吐血': '8c/lxhtuxue_thumb',
        '好激动': 'ae/lxhjidong_thumb',
        'lt切克闹': '73/ltqiekenao_thumb',
        'moc转发': 'cb/moczhuanfa_thumb',
        'ala蹦': 'b7/alabeng_thumb',
        'gst耐你': '1b/gstnaini_thumb',
        'xb压力': 'e0/xbyali_thumb',
        'din推撞': 'dd/dintuizhuang_thumb',
        '草泥马': '7a/shenshou_thumb',
        '神马': '60/horse2_thumb',
        '浮云': 'bc/fuyun_thumb',
        '给力': 'c9/geili_thumb',
        '围观': 'f2/wg_thumb',
        '威武': '70/vw_thumb',
        '熊猫': '6e/panda_thumb',
        '兔子': '81/rabbit_thumb',
        '奥特曼': 'bc/otm_thumb',
        '囧': '15/j_thumb',
        '互粉': '89/hufen_thumb',
        '礼物': 'c4/liwu_thumb',
        '呵呵': 'ac/smilea_thumb',
        '嘻嘻': '0b/tootha_thumb',
        '哈哈': '6a/laugh',
        '可爱': '14/tza_thumb',
        '可怜': 'af/kl_thumb',
        '挖鼻屎': 'a0/kbsa_thumb',
        '吃惊': 'f4/cj_thumb',
        '害羞': '6e/shamea_thumb',
        '挤眼': 'c3/zy_thumb',
        '闭嘴': '29/bz_thumb',
        '鄙视': '71/bs2_thumb',
        '爱你': '6d/lovea_thumb',
        '泪': '9d/sada_thumb',
        '偷笑': '19/heia_thumb',
        '亲亲': '8f/qq_thumb',
        '生病': 'b6/sb_thumb',
        '太开心': '58/mb_thumb',
        '懒得理你': '17/ldln_thumb',
        '右哼哼': '98/yhh_thumb',
        '左哼哼': '6d/zhh_thumb',
        '嘘': 'a6/x_thumb',
        '衰': 'af/cry',
        '委屈': '73/wq_thumb',
        '吐': '9e/t_thumb',
        '打哈欠': 'f3/k_thumb',
        '抱抱': '27/bba_thumb',
        '怒': '7c/angrya_thumb',
        '疑问': '5c/yw_thumb',
        '馋嘴': 'a5/cza_thumb',
        '拜拜': '70/88_thumb',
        '思考': 'e9/sk_thumb',
        '汗': '24/sweata_thumb',
        '困': '7f/sleepya_thumb',
        '睡觉': '6b/sleepa_thumb',
        '钱': '90/money_thumb',
        '失望': '0c/sw_thumb',
        '酷': '40/cool_thumb',
        '花心': '8c/hsa_thumb',
        '哼': '49/hatea_thumb',
        '鼓掌': '36/gza_thumb',
        '晕': 'd9/dizzya_thumb',
        '悲伤': '1a/bs_thumb',
        '抓狂': '62/crazya_thumb',
        '黑线': '91/h_thumb',
        '阴险': '6d/yx_thumb',
        '怒骂': '89/nm_thumb',
        '心': '40/hearta_thumb',
        '伤心': 'ea/unheart',
        '猪头': '58/pig',
        'ok': 'd6/ok_thumb',
        '耶': 'd9/ye_thumb',
        'good': 'd8/good_thumb',
        '不要': 'c7/no_thumb',
        '赞': 'd0/z2_thumb',
        '来': '40/come_thumb',
        '弱': 'd8/sad_thumb',
        '蜡烛': '91/lazu_thumb',
        '蛋糕': '6a/cake',
        '钟': 'd3/clock_thumb',
        '话筒': '1b/m_thumb'
    };
    var allFacesBase = 'http://img.t.sinajs.cn/t35/style/images/common/face/ext/normal/';
    return function(text){
        text = text || '';
        text = text.replace(regExp, function($0, $1) {
            var imgUrl = allFaces[$1];
            if (imgUrl) {
                imgUrl = allFacesBase + imgUrl + '.gif';
            }
            return !imgUrl ? $1 : '<img class="sina-comment-txt-face" title="' + $1 + '" alt="' + $1 + '" src="' + imgUrl + '" />';
        });
        return text;
    }
})();
exports.faceFilter = faceFilter;
var nativeTrim = String.prototype.trim;
var trim = function(str,characters){
    str = makeString(str);
    if(!characters && nativeTrim){
        return nativeTrim.call(str);
    }
    characters = defaultToWhiteSpace(characters);
    return str.replace(new RegExp('^' + characters + '+|' + characters + '+$', 'g'), '');
};
exports.trim = trim;
var makeString = function(obj){
    if(obj == null){
        return '';
    }
    return '' + obj;
};
exports.makeString = makeString;
var escapeRegExp = function(str) {
    return makeString(str).replace(/([.*+?^=!:${}()|[\]\/\\])/g, '\\$1');
};
var defaultToWhiteSpace = function(characters) {
    if(characters == null){
        return '\\s';
    }else if(characters.source){
        return characters.source;
    }else{
        return '[' + escapeRegExp(characters) + ']';
    }
};
var normalizeDate = function(time){
    if(!(time instanceof Date)){
        try{
            time = strToDate(time);
        }catch(e){
            time = new Date();
        }
    }
    time.year = time.getFullYear();
    time.month = time.getMonth()+1;
    time.day = time.getDate();
    time.hours = time.getHours();
    time.minute = time.getMinutes();
    time.seconds = time.getSeconds();
    return time;
};
var randomStr = function(len){
    if(len <= 0 || !len){
        len = 5;
    }
    var ret = '';
    for(var i = 0;i<len;i++){
        var r = random(0,AW.length);
        ret += AW.charAt(r);
    }
    return ret;
}
exports.randomStr = randomStr;
exports.normalizeDate = normalizeDate;
var rAF = (function(){
    var _raf = window.requestAnimationFrame ||
                window.webkitRequestAnimationFrame ||
                window.mozRequestAnimationFrame ||
                window.oRequestAnimationFrame;
    var _cRAF = window.cancelAnimationFrame ||
                window.webkitCancelRequestAnimationFrame ||
                window.mozCancelRequestAnimationFrame ||
                window.oCancelRequestAnimationFrame;
    return {
        start:function(){
            var args = Array.prototype.slice.call(arguments,0);
            if(this.hasRAF){
                return _raf.apply(window,args);
            }else{
                return setInterval.call(window,args[0],1000 / 60);
            }
        },
        stop:function(handle){
            if(this.hasRAF){
               return _cRAF.call(window,handle);
            }else{
                return clearInterval.call(window,handle);
            }
        },
        hasRAF:(_raf && _cRAF)
    }
})();
exports.rAF = rAF;
var bLength = function(val){
    if(!val) return 0;
    return val.replace(/[^\x00-\xff]/g,'aa').length;
}
exports.bLength = bLength;







var lcs_timeFormat = function(time,sys){
    //简单判断时间是否为0000-00-00 00:00:00
    if(!time || !(/^[1-2]\d{3}/.test(time))){
        return '--';
    }
    time = strToDate(time);
    if(!sys){
        sys = new Date();
    }else{
        sys = strToDate(sys);
    }
    var second = (sys.getTime() - time.getTime()) / 1000;
    normalizeDate(time);
    normalizeDate(sys);
    if(second <= 0){
        return '1秒前';
    }else if(second < 60){
        return floor(second)+'秒前';
    }else if(second < 3600){
        return floor(second / 60)+'分钟前';
    }else if(sys.year !== time.year){
        return time.year+'-'+timeFixed(time.month)+'-'+timeFixed(time.day);
    }else if(time.month === sys.month && time.day === sys.day){
        return timeFixed(time.hours)+':'+timeFixed(time.minute);
    }else{
        return timeFixed(time.month)+'-'+timeFixed(time.day)+' '+timeFixed(time.hours)+':'+timeFixed(time.minute);
    }
};
var lcs = exports.lcs = {};
lcs.timeFormat = lcs_timeFormat;
var lcs_planTimeStateForamt = function(start,end,status,sys){
    if(!sys){
        sys = new Date();
    }else{
        sys = strToDate(sys);
    }
    start = strToTime(start);
    end = strToTime(end);
    sys = sys.getTime();
    if(status == 2){
        return "距运行" + Math.ceil((start - sys )/ 1000 / 86400) + "天";
    }else if(status == 3){
        return "剩余" + Math.ceil((end - sys) / 1000 / 86400) + "天";
    }else{
        return "已终止";
    }

}
lcs.planTimeStateFormat = lcs_planTimeStateForamt;
});
define("mod-util/0.3.0/lib/underscore-debug", [], function(require, exports, module){
//     Underscore.js 1.7.0
//     http://underscorejs.org
//     (c) 2009-2014 Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
//     Underscore may be freely distributed under the MIT license.

(function() {

  // Baseline setup
  // --------------

  // Establish the root object, `window` in the browser, or `exports` on the server.
  var root = this;

  // Save the previous value of the `_` variable.
  var previousUnderscore = root._;

  // Save bytes in the minified (but not gzipped) version:
  var ArrayProto = Array.prototype, ObjProto = Object.prototype, FuncProto = Function.prototype;

  // Create quick reference variables for speed access to core prototypes.
  var
    push             = ArrayProto.push,
    slice            = ArrayProto.slice,
    toString         = ObjProto.toString,
    hasOwnProperty   = ObjProto.hasOwnProperty;

  // All **ECMAScript 5** native function implementations that we hope to use
  // are declared here.
  var
    nativeIsArray      = Array.isArray,
    nativeKeys         = Object.keys,
    nativeBind         = FuncProto.bind,
    nativeCreate       = Object.create;

  // Reusable constructor function for prototype setting.
  var Ctor = function(){};

  // Create a safe reference to the Underscore object for use below.
  var _ = function(obj) {
    if (obj instanceof _) return obj;
    if (!(this instanceof _)) return new _(obj);
    this._wrapped = obj;
  };

  // Export the Underscore object for **Node.js**, with
  // backwards-compatibility for the old `require()` API. If we're in
  // the browser, add `_` as a global object.
  if (typeof exports !== 'undefined') {
    if (typeof module !== 'undefined' && module.exports) {
      exports = module.exports = _;
    }
    exports._ = _;
  } else {
    root._ = _;
  }

  // Current version.
  _.VERSION = '1.7.0';

  // Internal function that returns an efficient (for current engines) version
  // of the passed-in callback, to be repeatedly applied in other Underscore
  // functions.
  var optimizeCb = function(func, context, argCount) {
    if (context === void 0) return func;
    switch (argCount == null ? 3 : argCount) {
      case 1: return function(value) {
        return func.call(context, value);
      };
      case 2: return function(value, other) {
        return func.call(context, value, other);
      };
      case 3: return function(value, index, collection) {
        return func.call(context, value, index, collection);
      };
      case 4: return function(accumulator, value, index, collection) {
        return func.call(context, accumulator, value, index, collection);
      };
    }
    return function() {
      return func.apply(context, arguments);
    };
  };

  // A mostly-internal function to generate callbacks that can be applied
  // to each element in a collection, returning the desired result — either
  // identity, an arbitrary callback, a property matcher, or a property accessor.
  var cb = function(value, context, argCount) {
    if (value == null) return _.identity;
    if (_.isFunction(value)) return optimizeCb(value, context, argCount);
    if (_.isObject(value)) return _.matches(value);
    return _.property(value);
  };
  _.iteratee = function(value, context) {
    return cb(value, context, Infinity);
  };

  // An internal function for creating assigner functions.
  var createAssigner = function(keysFunc) {
    return function(obj) {
      var length = arguments.length;
      if (length < 2 || obj == null) return obj;
      for (var index = 0; index < length; index++) {
        var source = arguments[index],
            keys = keysFunc(source),
            l = keys.length;
        for (var i = 0; i < l; i++) {
          var key = keys[i];
          obj[key] = source[key];
        }
      }
      return obj;
    };
  };

  // An internal function for creating a new object that inherts from another.
  var baseCreate = function(prototype) {
    if (!_.isObject(prototype)) return {};
    if (nativeCreate) return nativeCreate(prototype);
    Ctor.prototype = prototype;
    var result = new Ctor;
    Ctor.prototype = null;
    return result;
  };

  // Collection Functions
  // --------------------

  // The cornerstone, an `each` implementation, aka `forEach`.
  // Handles raw objects in addition to array-likes. Treats all
  // sparse array-likes as if they were dense.
  _.each = _.forEach = function(obj, iteratee, context) {
    if (obj == null) return obj;
    iteratee = optimizeCb(iteratee, context);
    var i, length = obj.length;
    if (length === +length) {
      for (i = 0; i < length; i++) {
        iteratee(obj[i], i, obj);
      }
    } else {
      var keys = _.keys(obj);
      for (i = 0, length = keys.length; i < length; i++) {
        iteratee(obj[keys[i]], keys[i], obj);
      }
    }
    return obj;
  };

  // Return the results of applying the iteratee to each element.
  _.map = _.collect = function(obj, iteratee, context) {
    if (obj == null) return [];
    iteratee = cb(iteratee, context);
    var keys = obj.length !== +obj.length && _.keys(obj),
        length = (keys || obj).length,
        results = Array(length),
        currentKey;
    for (var index = 0; index < length; index++) {
      currentKey = keys ? keys[index] : index;
      results[index] = iteratee(obj[currentKey], currentKey, obj);
    }
    return results;
  };

  // **Reduce** builds up a single result from a list of values, aka `inject`,
  // or `foldl`.
  _.reduce = _.foldl = _.inject = function(obj, iteratee, memo, context) {
    if (obj == null) obj = [];
    iteratee = optimizeCb(iteratee, context, 4);
    var keys = obj.length !== +obj.length && _.keys(obj),
        length = (keys || obj).length,
        index = 0, currentKey;
    if (arguments.length < 3) {
      memo = obj[keys ? keys[index++] : index++];
    }
    for (; index < length; index++) {
      currentKey = keys ? keys[index] : index;
      memo = iteratee(memo, obj[currentKey], currentKey, obj);
    }
    return memo;
  };

  // The right-associative version of reduce, also known as `foldr`.
  _.reduceRight = _.foldr = function(obj, iteratee, memo, context) {
    if (obj == null) obj = [];
    iteratee = optimizeCb(iteratee, context, 4);
    var keys = obj.length !== + obj.length && _.keys(obj),
        index = (keys || obj).length,
        currentKey;
    if (arguments.length < 3) {
      memo = obj[keys ? keys[--index] : --index];
    }
    while (index-- > 0) {
      currentKey = keys ? keys[index] : index;
      memo = iteratee(memo, obj[currentKey], currentKey, obj);
    }
    return memo;
  };

  // Return the first value which passes a truth test. Aliased as `detect`.
  _.find = _.detect = function(obj, predicate, context) {
    var key;
    if (obj.length === +obj.length) {
      key = _.findIndex(obj, predicate, context);
    } else {
      key = _.findKey(obj, predicate, context);
    }
    if (key !== void 0 && key !== -1) return obj[key];
  };

  // Return all the elements that pass a truth test.
  // Aliased as `select`.
  _.filter = _.select = function(obj, predicate, context) {
    var results = [];
    if (obj == null) return results;
    predicate = cb(predicate, context);
    _.each(obj, function(value, index, list) {
      if (predicate(value, index, list)) results.push(value);
    });
    return results;
  };

  // Return all the elements for which a truth test fails.
  _.reject = function(obj, predicate, context) {
    return _.filter(obj, _.negate(cb(predicate)), context);
  };

  // Determine whether all of the elements match a truth test.
  // Aliased as `all`.
  _.every = _.all = function(obj, predicate, context) {
    if (obj == null) return true;
    predicate = cb(predicate, context);
    var keys = obj.length !== +obj.length && _.keys(obj),
        length = (keys || obj).length,
        index, currentKey;
    for (index = 0; index < length; index++) {
      currentKey = keys ? keys[index] : index;
      if (!predicate(obj[currentKey], currentKey, obj)) return false;
    }
    return true;
  };

  // Determine if at least one element in the object matches a truth test.
  // Aliased as `any`.
  _.some = _.any = function(obj, predicate, context) {
    if (obj == null) return false;
    predicate = cb(predicate, context);
    var keys = obj.length !== +obj.length && _.keys(obj),
        length = (keys || obj).length,
        index, currentKey;
    for (index = 0; index < length; index++) {
      currentKey = keys ? keys[index] : index;
      if (predicate(obj[currentKey], currentKey, obj)) return true;
    }
    return false;
  };

  // Determine if the array or object contains a given value (using `===`).
  // Aliased as `includes` and `include`.
  _.contains = _.includes = _.include = function(obj, target, fromIndex) {
    if (obj == null) return false;
    if (obj.length !== +obj.length) obj = _.values(obj);
    return _.indexOf(obj, target, typeof fromIndex == 'number' && fromIndex) >= 0;
  };

  // Invoke a method (with arguments) on every item in a collection.
  _.invoke = function(obj, method) {
    var args = slice.call(arguments, 2);
    var isFunc = _.isFunction(method);
    return _.map(obj, function(value) {
      return (isFunc ? method : value[method]).apply(value, args);
    });
  };

  // Convenience version of a common use case of `map`: fetching a property.
  _.pluck = function(obj, key) {
    return _.map(obj, _.property(key));
  };

  // Convenience version of a common use case of `filter`: selecting only objects
  // containing specific `key:value` pairs.
  _.where = function(obj, attrs) {
    return _.filter(obj, _.matches(attrs));
  };

  // Convenience version of a common use case of `find`: getting the first object
  // containing specific `key:value` pairs.
  _.findWhere = function(obj, attrs) {
    return _.find(obj, _.matches(attrs));
  };

  // Return the maximum element (or element-based computation).
  _.max = function(obj, iteratee, context) {
    var result = -Infinity, lastComputed = -Infinity,
        value, computed;
    if (iteratee == null && obj != null) {
      obj = obj.length === +obj.length ? obj : _.values(obj);
      for (var i = 0, length = obj.length; i < length; i++) {
        value = obj[i];
        if (value > result) {
          result = value;
        }
      }
    } else {
      iteratee = cb(iteratee, context);
      _.each(obj, function(value, index, list) {
        computed = iteratee(value, index, list);
        if (computed > lastComputed || computed === -Infinity && result === -Infinity) {
          result = value;
          lastComputed = computed;
        }
      });
    }
    return result;
  };

  // Return the minimum element (or element-based computation).
  _.min = function(obj, iteratee, context) {
    var result = Infinity, lastComputed = Infinity,
        value, computed;
    if (iteratee == null && obj != null) {
      obj = obj.length === +obj.length ? obj : _.values(obj);
      for (var i = 0, length = obj.length; i < length; i++) {
        value = obj[i];
        if (value < result) {
          result = value;
        }
      }
    } else {
      iteratee = cb(iteratee, context);
      _.each(obj, function(value, index, list) {
        computed = iteratee(value, index, list);
        if (computed < lastComputed || computed === Infinity && result === Infinity) {
          result = value;
          lastComputed = computed;
        }
      });
    }
    return result;
  };

  // Shuffle a collection, using the modern version of the
  // [Fisher-Yates shuffle](http://en.wikipedia.org/wiki/Fisher–Yates_shuffle).
  _.shuffle = function(obj) {
    var set = obj && obj.length === +obj.length ? obj : _.values(obj);
    var length = set.length;
    var shuffled = Array(length);
    for (var index = 0, rand; index < length; index++) {
      rand = _.random(0, index);
      if (rand !== index) shuffled[index] = shuffled[rand];
      shuffled[rand] = set[index];
    }
    return shuffled;
  };

  // Sample **n** random values from a collection.
  // If **n** is not specified, returns a single random element.
  // The internal `guard` argument allows it to work with `map`.
  _.sample = function(obj, n, guard) {
    if (n == null || guard) {
      if (obj.length !== +obj.length) obj = _.values(obj);
      return obj[_.random(obj.length - 1)];
    }
    return _.shuffle(obj).slice(0, Math.max(0, n));
  };

  // Sort the object's values by a criterion produced by an iteratee.
  _.sortBy = function(obj, iteratee, context) {
    iteratee = cb(iteratee, context);
    return _.pluck(_.map(obj, function(value, index, list) {
      return {
        value: value,
        index: index,
        criteria: iteratee(value, index, list)
      };
    }).sort(function(left, right) {
      var a = left.criteria;
      var b = right.criteria;
      if (a !== b) {
        if (a > b || a === void 0) return 1;
        if (a < b || b === void 0) return -1;
      }
      return left.index - right.index;
    }), 'value');
  };

  // An internal function used for aggregate "group by" operations.
  var group = function(behavior) {
    return function(obj, iteratee, context) {
      var result = {};
      iteratee = cb(iteratee, context);
      _.each(obj, function(value, index) {
        var key = iteratee(value, index, obj);
        behavior(result, value, key);
      });
      return result;
    };
  };

  // Groups the object's values by a criterion. Pass either a string attribute
  // to group by, or a function that returns the criterion.
  _.groupBy = group(function(result, value, key) {
    if (_.has(result, key)) result[key].push(value); else result[key] = [value];
  });

  // Indexes the object's values by a criterion, similar to `groupBy`, but for
  // when you know that your index values will be unique.
  _.indexBy = group(function(result, value, key) {
    result[key] = value;
  });

  // Counts instances of an object that group by a certain criterion. Pass
  // either a string attribute to count by, or a function that returns the
  // criterion.
  _.countBy = group(function(result, value, key) {
    if (_.has(result, key)) result[key]++; else result[key] = 1;
  });

  // Use a comparator function to figure out the smallest index at which
  // an object should be inserted so as to maintain order. Uses binary search.
  _.sortedIndex = function(array, obj, iteratee, context) {
    iteratee = cb(iteratee, context, 1);
    var value = iteratee(obj);
    var low = 0, high = array.length;
    while (low < high) {
      var mid = Math.floor((low + high) / 2);
      if (iteratee(array[mid]) < value) low = mid + 1; else high = mid;
    }
    return low;
  };

  // Safely create a real, live array from anything iterable.
  _.toArray = function(obj) {
    if (!obj) return [];
    if (_.isArray(obj)) return slice.call(obj);
    if (obj.length === +obj.length) return _.map(obj, _.identity);
    return _.values(obj);
  };

  // Return the number of elements in an object.
  _.size = function(obj) {
    if (obj == null) return 0;
    return obj.length === +obj.length ? obj.length : _.keys(obj).length;
  };

  // Split a collection into two arrays: one whose elements all satisfy the given
  // predicate, and one whose elements all do not satisfy the predicate.
  _.partition = function(obj, predicate, context) {
    predicate = cb(predicate, context);
    var pass = [], fail = [];
    _.each(obj, function(value, key, obj) {
      (predicate(value, key, obj) ? pass : fail).push(value);
    });
    return [pass, fail];
  };

  // Array Functions
  // ---------------

  // Get the first element of an array. Passing **n** will return the first N
  // values in the array. Aliased as `head` and `take`. The **guard** check
  // allows it to work with `_.map`.
  _.first = _.head = _.take = function(array, n, guard) {
    if (array == null) return void 0;
    if (n == null || guard) return array[0];
    return _.initial(array, array.length - n);
  };

  // Returns everything but the last entry of the array. Especially useful on
  // the arguments object. Passing **n** will return all the values in
  // the array, excluding the last N. The **guard** check allows it to work with
  // `_.map`.
  _.initial = function(array, n, guard) {
    return slice.call(array, 0, Math.max(0, array.length - (n == null || guard ? 1 : n)));
  };

  // Get the last element of an array. Passing **n** will return the last N
  // values in the array. The **guard** check allows it to work with `_.map`.
  _.last = function(array, n, guard) {
    if (array == null) return void 0;
    if (n == null || guard) return array[array.length - 1];
    return _.rest(array, Math.max(0, array.length - n));
  };

  // Returns everything but the first entry of the array. Aliased as `tail` and `drop`.
  // Especially useful on the arguments object. Passing an **n** will return
  // the rest N values in the array. The **guard**
  // check allows it to work with `_.map`.
  _.rest = _.tail = _.drop = function(array, n, guard) {
    return slice.call(array, n == null || guard ? 1 : n);
  };

  // Trim out all falsy values from an array.
  _.compact = function(array) {
    return _.filter(array, _.identity);
  };

  // Internal implementation of a recursive `flatten` function.
  var flatten = function(input, shallow, strict, startIndex) {
    var output = [], idx = 0, value;
    for (var i = startIndex || 0, length = input && input.length; i < length; i++) {
      value = input[i];
      if (value && value.length >= 0 && (_.isArray(value) || _.isArguments(value))) {
        //flatten current level of array or arguments object
        if (!shallow) value = flatten(value, shallow, strict);
        var j = 0, len = value.length;
        output.length += len;
        while (j < len) {
          output[idx++] = value[j++];
        }
      } else if (!strict) {
        output[idx++] = value;
      }
    }
    return output;
  };

  // Flatten out an array, either recursively (by default), or just one level.
  _.flatten = function(array, shallow) {
    return flatten(array, shallow, false);
  };

  // Return a version of the array that does not contain the specified value(s).
  _.without = function(array) {
    return _.difference(array, slice.call(arguments, 1));
  };

  // Produce a duplicate-free version of the array. If the array has already
  // been sorted, you have the option of using a faster algorithm.
  // Aliased as `unique`.
  _.uniq = _.unique = function(array, isSorted, iteratee, context) {
    if (array == null) return [];
    if (!_.isBoolean(isSorted)) {
      context = iteratee;
      iteratee = isSorted;
      isSorted = false;
    }
    if (iteratee != null) iteratee = cb(iteratee, context);
    var result = [];
    var seen = [];
    for (var i = 0, length = array.length; i < length; i++) {
      var value = array[i],
          computed = iteratee ? iteratee(value, i, array) : value;
      if (isSorted) {
        if (!i || seen !== computed) result.push(value);
        seen = computed;
      } else if (iteratee) {
        if (!_.contains(seen, computed)) {
          seen.push(computed);
          result.push(value);
        }
      } else if (!_.contains(result, value)) {
        result.push(value);
      }
    }
    return result;
  };

  // Produce an array that contains the union: each distinct element from all of
  // the passed-in arrays.
  _.union = function() {
    return _.uniq(flatten(arguments, true, true));
  };

  // Produce an array that contains every item shared between all the
  // passed-in arrays.
  _.intersection = function(array) {
    if (array == null) return [];
    var result = [];
    var argsLength = arguments.length;
    for (var i = 0, length = array.length; i < length; i++) {
      var item = array[i];
      if (_.contains(result, item)) continue;
      for (var j = 1; j < argsLength; j++) {
        if (!_.contains(arguments[j], item)) break;
      }
      if (j === argsLength) result.push(item);
    }
    return result;
  };

  // Take the difference between one array and a number of other arrays.
  // Only the elements present in just the first array will remain.
  _.difference = function(array) {
    var rest = flatten(arguments, true, true, 1);
    return _.filter(array, function(value){
      return !_.contains(rest, value);
    });
  };

  // Zip together multiple lists into a single array -- elements that share
  // an index go together.
  _.zip = function(array) {
    if (array == null) return [];
    var length = _.max(arguments, 'length').length;
    var results = Array(length);
    while (length-- > 0) {
      results[length] = _.pluck(arguments, length);
    }
    return results;
  };

  // Complement of _.zip. Unzip accepts an array of arrays and groups
  // each array's elements on shared indices
  _.unzip = function(array) {
    return _.zip.apply(null, array);
  };

  // Converts lists into objects. Pass either a single array of `[key, value]`
  // pairs, or two parallel arrays of the same length -- one of keys, and one of
  // the corresponding values.
  _.object = function(list, values) {
    if (list == null) return {};
    var result = {};
    for (var i = 0, length = list.length; i < length; i++) {
      if (values) {
        result[list[i]] = values[i];
      } else {
        result[list[i][0]] = list[i][1];
      }
    }
    return result;
  };

  // Return the position of the first occurrence of an item in an array,
  // or -1 if the item is not included in the array.
  // If the array is large and already in sort order, pass `true`
  // for **isSorted** to use binary search.
  _.indexOf = function(array, item, isSorted) {
    var i = 0, length = array && array.length;
    if (typeof isSorted == 'number') {
      i = isSorted < 0 ? Math.max(0, length + isSorted) : isSorted;
    } else if (isSorted && length) {
      i = _.sortedIndex(array, item);
      return array[i] === item ? i : -1;
    }
    for (; i < length; i++) if (array[i] === item) return i;
    return -1;
  };

  _.lastIndexOf = function(array, item, from) {
    var idx = array ? array.length : 0;
    if (typeof from == 'number') {
      idx = from < 0 ? idx + from + 1 : Math.min(idx, from + 1);
    }
    while (--idx >= 0) if (array[idx] === item) return idx;
    return -1;
  };

  // Returns the first index on an array-like that passes a predicate test
  _.findIndex = function(array, predicate, context) {
    predicate = cb(predicate, context);
    var length = array != null ? array.length : 0;
    for (var i = 0; i < length; i++) {
      if (predicate(array[i], i, array)) return i;
    }
    return -1;
  };

  // Generate an integer Array containing an arithmetic progression. A port of
  // the native Python `range()` function. See
  // [the Python documentation](http://docs.python.org/library/functions.html#range).
  _.range = function(start, stop, step) {
    if (arguments.length <= 1) {
      stop = start || 0;
      start = 0;
    }
    step = step || 1;

    var length = Math.max(Math.ceil((stop - start) / step), 0);
    var range = Array(length);

    for (var idx = 0; idx < length; idx++, start += step) {
      range[idx] = start;
    }

    return range;
  };

  // Function (ahem) Functions
  // ------------------

  // Determines whether to execute a function as a constructor
  // or a normal function with the provided arguments
  var executeBound = function(sourceFunc, boundFunc, context, callingContext, args) {
    if (!(callingContext instanceof boundFunc)) return sourceFunc.apply(context, args);
    var self = baseCreate(sourceFunc.prototype);
    var result = sourceFunc.apply(self, args);
    if (_.isObject(result)) return result;
    return self;
  };

  // Create a function bound to a given object (assigning `this`, and arguments,
  // optionally). Delegates to **ECMAScript 5**'s native `Function.bind` if
  // available.
  _.bind = function(func, context) {
    if (nativeBind && func.bind === nativeBind) return nativeBind.apply(func, slice.call(arguments, 1));
    if (!_.isFunction(func)) throw new TypeError('Bind must be called on a function');
    var args = slice.call(arguments, 2);
    return function bound() {
      return executeBound(func, bound, context, this, args.concat(slice.call(arguments)));
    };
  };

  // Partially apply a function by creating a version that has had some of its
  // arguments pre-filled, without changing its dynamic `this` context. _ acts
  // as a placeholder, allowing any combination of arguments to be pre-filled.
  _.partial = function(func) {
    var boundArgs = slice.call(arguments, 1);
    return function bound() {
      var position = 0;
      var args = boundArgs.slice();
      for (var i = 0, length = args.length; i < length; i++) {
        if (args[i] === _) args[i] = arguments[position++];
      }
      while (position < arguments.length) args.push(arguments[position++]);
      return executeBound(func, bound, this, this, args);
    };
  };

  // Bind a number of an object's methods to that object. Remaining arguments
  // are the method names to be bound. Useful for ensuring that all callbacks
  // defined on an object belong to it.
  _.bindAll = function(obj) {
    var i, length = arguments.length, key;
    if (length <= 1) throw new Error('bindAll must be passed function names');
    for (i = 1; i < length; i++) {
      key = arguments[i];
      obj[key] = _.bind(obj[key], obj);
    }
    return obj;
  };

  // Memoize an expensive function by storing its results.
  _.memoize = function(func, hasher) {
    var memoize = function(key) {
      var cache = memoize.cache;
      var address = '' + (hasher ? hasher.apply(this, arguments) : key);
      if (!_.has(cache, address)) cache[address] = func.apply(this, arguments);
      return cache[address];
    };
    memoize.cache = {};
    return memoize;
  };

  // Delays a function for the given number of milliseconds, and then calls
  // it with the arguments supplied.
  _.delay = function(func, wait) {
    var args = slice.call(arguments, 2);
    return setTimeout(function(){
      return func.apply(null, args);
    }, wait);
  };

  // Defers a function, scheduling it to run after the current call stack has
  // cleared.
  _.defer = _.partial(_.delay, _, 1);

  // Returns a function, that, when invoked, will only be triggered at most once
  // during a given window of time. Normally, the throttled function will run
  // as much as it can, without ever going more than once per `wait` duration;
  // but if you'd like to disable the execution on the leading edge, pass
  // `{leading: false}`. To disable execution on the trailing edge, ditto.
  _.throttle = function(func, wait, options) {
    var context, args, result;
    var timeout = null;
    var previous = 0;
    if (!options) options = {};
    var later = function() {
      previous = options.leading === false ? 0 : _.now();
      timeout = null;
      result = func.apply(context, args);
      if (!timeout) context = args = null;
    };
    return function() {
      var now = _.now();
      if (!previous && options.leading === false) previous = now;
      var remaining = wait - (now - previous);
      context = this;
      args = arguments;
      if (remaining <= 0 || remaining > wait) {
        if (timeout) {
          clearTimeout(timeout);
          timeout = null;
        }
        previous = now;
        result = func.apply(context, args);
        if (!timeout) context = args = null;
      } else if (!timeout && options.trailing !== false) {
        timeout = setTimeout(later, remaining);
      }
      return result;
    };
  };

  // Returns a function, that, as long as it continues to be invoked, will not
  // be triggered. The function will be called after it stops being called for
  // N milliseconds. If `immediate` is passed, trigger the function on the
  // leading edge, instead of the trailing.
  _.debounce = function(func, wait, immediate) {
    var timeout, args, context, timestamp, result;

    var later = function() {
      var last = _.now() - timestamp;

      if (last < wait && last >= 0) {
        timeout = setTimeout(later, wait - last);
      } else {
        timeout = null;
        if (!immediate) {
          result = func.apply(context, args);
          if (!timeout) context = args = null;
        }
      }
    };

    return function() {
      context = this;
      args = arguments;
      timestamp = _.now();
      var callNow = immediate && !timeout;
      if (!timeout) timeout = setTimeout(later, wait);
      if (callNow) {
        result = func.apply(context, args);
        context = args = null;
      }

      return result;
    };
  };

  // Returns the first function passed as an argument to the second,
  // allowing you to adjust arguments, run code before and after, and
  // conditionally execute the original function.
  _.wrap = function(func, wrapper) {
    return _.partial(wrapper, func);
  };

  // Returns a negated version of the passed-in predicate.
  _.negate = function(predicate) {
    return function() {
      return !predicate.apply(this, arguments);
    };
  };

  // Returns a function that is the composition of a list of functions, each
  // consuming the return value of the function that follows.
  _.compose = function() {
    var args = arguments;
    var start = args.length - 1;
    return function() {
      var i = start;
      var result = args[start].apply(this, arguments);
      while (i--) result = args[i].call(this, result);
      return result;
    };
  };

  // Returns a function that will only be executed on and after the Nth call.
  _.after = function(times, func) {
    return function() {
      if (--times < 1) {
        return func.apply(this, arguments);
      }
    };
  };

  // Returns a function that will only be executed up to (but not including) the Nth call.
  _.before = function(times, func) {
    var memo;
    return function() {
      if (--times > 0) {
        memo = func.apply(this, arguments);
      }
      if (times <= 1) func = null;
      return memo;
    };
  };

  // Returns a function that will be executed at most one time, no matter how
  // often you call it. Useful for lazy initialization.
  _.once = _.partial(_.before, 2);

  // Object Functions
  // ----------------

  // Keys in IE < 9 that won't be iterated by `for key in ...` and thus missed.
  var hasEnumBug = !{toString: null}.propertyIsEnumerable('toString');
  var nonEnumerableProps = ['constructor', 'valueOf', 'isPrototypeOf', 'toString',
                      'propertyIsEnumerable', 'hasOwnProperty', 'toLocaleString'];

  function collectNonEnumProps(obj, keys) {
    var nonEnumIdx = nonEnumerableProps.length;
    var proto = typeof obj.constructor === 'function' ? FuncProto : ObjProto;

    while (nonEnumIdx--) {
      var prop = nonEnumerableProps[nonEnumIdx];
      if (prop === 'constructor' ? _.has(obj, prop) : prop in obj &&
        obj[prop] !== proto[prop] && !_.contains(keys, prop)) {
        keys.push(prop);
      }
    }
  }

  // Retrieve the names of an object's own properties.
  // Delegates to **ECMAScript 5**'s native `Object.keys`
  _.keys = function(obj) {
    if (!_.isObject(obj)) return [];
    if (nativeKeys) return nativeKeys(obj);
    var keys = [];
    for (var key in obj) if (_.has(obj, key)) keys.push(key);
    // Ahem, IE < 9.
    if (hasEnumBug) collectNonEnumProps(obj, keys);
    return keys;
  };

  // Retrieve all the property names of an object.
  _.keysIn = function(obj) {
    if (!_.isObject(obj)) return [];
    var keys = [];
    for (var key in obj) keys.push(key);
    // Ahem, IE < 9.
    if (hasEnumBug) collectNonEnumProps(obj, keys);
    return keys;
  };

  // Retrieve the values of an object's properties.
  _.values = function(obj) {
    var keys = _.keys(obj);
    var length = keys.length;
    var values = Array(length);
    for (var i = 0; i < length; i++) {
      values[i] = obj[keys[i]];
    }
    return values;
  };

  // Convert an object into a list of `[key, value]` pairs.
  _.pairs = function(obj) {
    var keys = _.keys(obj);
    var length = keys.length;
    var pairs = Array(length);
    for (var i = 0; i < length; i++) {
      pairs[i] = [keys[i], obj[keys[i]]];
    }
    return pairs;
  };

  // Invert the keys and values of an object. The values must be serializable.
  _.invert = function(obj) {
    var result = {};
    var keys = _.keys(obj);
    for (var i = 0, length = keys.length; i < length; i++) {
      result[obj[keys[i]]] = keys[i];
    }
    return result;
  };

  // Return a sorted list of the function names available on the object.
  // Aliased as `methods`
  _.functions = _.methods = function(obj) {
    var names = [];
    for (var key in obj) {
      if (_.isFunction(obj[key])) names.push(key);
    }
    return names.sort();
  };

  // Extend a given object with all the properties in passed-in object(s).
  _.extend = createAssigner(_.keysIn);

  // Assigns a given object with all the own properties in the passed-in object(s)
  // (https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object/assign)
  _.assign = createAssigner(_.keys);

  // Returns the first key on an object that passes a predicate test
  _.findKey = function(obj, predicate, context) {
    predicate = cb(predicate, context);
    var keys = _.keys(obj), key;
    for (var i = 0, length = keys.length; i < length; i++) {
      key = keys[i];
      if (predicate(obj[key], key, obj)) return key;
    }
  };

  // Return a copy of the object only containing the whitelisted properties.
  _.pick = function(obj, iteratee, context) {
    var result = {}, key;
    if (obj == null) return result;
    if (_.isFunction(iteratee)) {
      iteratee = optimizeCb(iteratee, context);
      for (key in obj) {
        var value = obj[key];
        if (iteratee(value, key, obj)) result[key] = value;
      }
    } else {
      var keys = flatten(arguments, false, false, 1);
      obj = new Object(obj);
      for (var i = 0, length = keys.length; i < length; i++) {
        key = keys[i];
        if (key in obj) result[key] = obj[key];
      }
    }
    return result;
  };

   // Return a copy of the object without the blacklisted properties.
  _.omit = function(obj, iteratee, context) {
    if (_.isFunction(iteratee)) {
      iteratee = _.negate(iteratee);
    } else {
      var keys = _.map(flatten(arguments, false, false, 1), String);
      iteratee = function(value, key) {
        return !_.contains(keys, key);
      };
    }
    return _.pick(obj, iteratee, context);
  };

  // Fill in a given object with default properties.
  _.defaults = function(obj) {
    if (!_.isObject(obj)) return obj;
    for (var i = 1, length = arguments.length; i < length; i++) {
      var source = arguments[i];
      for (var prop in source) {
        if (obj[prop] === void 0) obj[prop] = source[prop];
      }
    }
    return obj;
  };

  // Creates an object that inherits from the given prototype object.
  // If additional properties are provided then they will be added to the
  // created object.
  _.create = function(prototype, props) {
    var result = baseCreate(prototype);
    if (props) _.assign(result, props);
    return result;
  };

  // Create a (shallow-cloned) duplicate of an object.
  _.clone = function(obj) {
    if (!_.isObject(obj)) return obj;
    return _.isArray(obj) ? obj.slice() : _.extend({}, obj);
  };

  // Invokes interceptor with the obj, and then returns obj.
  // The primary purpose of this method is to "tap into" a method chain, in
  // order to perform operations on intermediate results within the chain.
  _.tap = function(obj, interceptor) {
    interceptor(obj);
    return obj;
  };

  // Internal recursive comparison function for `isEqual`.
  var eq = function(a, b, aStack, bStack) {
    // Identical objects are equal. `0 === -0`, but they aren't identical.
    // See the [Harmony `egal` proposal](http://wiki.ecmascript.org/doku.php?id=harmony:egal).
    if (a === b) return a !== 0 || 1 / a === 1 / b;
    // A strict comparison is necessary because `null == undefined`.
    if (a == null || b == null) return a === b;
    // Unwrap any wrapped objects.
    if (a instanceof _) a = a._wrapped;
    if (b instanceof _) b = b._wrapped;
    // Compare `[[Class]]` names.
    var className = toString.call(a);
    if (className !== toString.call(b)) return false;
    switch (className) {
      // Strings, numbers, regular expressions, dates, and booleans are compared by value.
      case '[object RegExp]':
      // RegExps are coerced to strings for comparison (Note: '' + /a/i === '/a/i')
      case '[object String]':
        // Primitives and their corresponding object wrappers are equivalent; thus, `"5"` is
        // equivalent to `new String("5")`.
        return '' + a === '' + b;
      case '[object Number]':
        // `NaN`s are equivalent, but non-reflexive.
        // Object(NaN) is equivalent to NaN
        if (+a !== +a) return +b !== +b;
        // An `egal` comparison is performed for other numeric values.
        return +a === 0 ? 1 / +a === 1 / b : +a === +b;
      case '[object Date]':
      case '[object Boolean]':
        // Coerce dates and booleans to numeric primitive values. Dates are compared by their
        // millisecond representations. Note that invalid dates with millisecond representations
        // of `NaN` are not equivalent.
        return +a === +b;
    }

    var areArrays = className === '[object Array]';
    if (!areArrays) {
      if (typeof a != 'object' || typeof b != 'object') return false;

      // Objects with different constructors are not equivalent, but `Object`s or `Array`s
      // from different frames are.
      var aCtor = a.constructor, bCtor = b.constructor;
      if (aCtor !== bCtor && !(_.isFunction(aCtor) && aCtor instanceof aCtor &&
                               _.isFunction(bCtor) && bCtor instanceof bCtor)
                          && ('constructor' in a && 'constructor' in b)) {
        return false;
      }
    }
    // Assume equality for cyclic structures. The algorithm for detecting cyclic
    // structures is adapted from ES 5.1 section 15.12.3, abstract operation `JO`.
    var length = aStack.length;
    while (length--) {
      // Linear search. Performance is inversely proportional to the number of
      // unique nested structures.
      if (aStack[length] === a) return bStack[length] === b;
    }

    // Add the first object to the stack of traversed objects.
    aStack.push(a);
    bStack.push(b);

    // Recursively compare objects and arrays.
    if (areArrays) {
      // Compare array lengths to determine if a deep comparison is necessary.
      length = a.length;
      if (length !== b.length) return false;
      // Deep compare the contents, ignoring non-numeric properties.
      while (length--) {
        if (!eq(a[length], b[length], aStack, bStack)) return false;
      }
    } else {
      // Deep compare objects.
      var keys = _.keys(a), key;
      length = keys.length;
      // Ensure that both objects contain the same number of properties before comparing deep equality.
      if (_.keys(b).length !== length) return false;
      while (length--) {
        // Deep compare each member
        key = keys[length];
        if (!(_.has(b, key) && eq(a[key], b[key], aStack, bStack))) return false;
      }
    }
    // Remove the first object from the stack of traversed objects.
    aStack.pop();
    bStack.pop();
    return true;
  };

  // Perform a deep comparison to check if two objects are equal.
  _.isEqual = function(a, b) {
    return eq(a, b, [], []);
  };

  // Is a given array, string, or object empty?
  // An "empty" object has no enumerable own-properties.
  _.isEmpty = function(obj) {
    if (obj == null) return true;
    if (_.isArray(obj) || _.isString(obj) || _.isArguments(obj)) return obj.length === 0;
    for (var key in obj) if (_.has(obj, key)) return false;
    return true;
  };

  // Is a given value a DOM element?
  _.isElement = function(obj) {
    return !!(obj && obj.nodeType === 1);
  };

  // Is a given value an array?
  // Delegates to ECMA5's native Array.isArray
  _.isArray = nativeIsArray || function(obj) {
    return toString.call(obj) === '[object Array]';
  };

  // Is a given variable an object?
  _.isObject = function(obj) {
    var type = typeof obj;
    return type === 'function' || type === 'object' && !!obj;
  };

  // Add some isType methods: isArguments, isFunction, isString, isNumber, isDate, isRegExp, isError.
  _.each(['Arguments', 'Function', 'String', 'Number', 'Date', 'RegExp', 'Error'], function(name) {
    _['is' + name] = function(obj) {
      return toString.call(obj) === '[object ' + name + ']';
    };
  });

  // Define a fallback version of the method in browsers (ahem, IE < 9), where
  // there isn't any inspectable "Arguments" type.
  if (!_.isArguments(arguments)) {
    _.isArguments = function(obj) {
      return _.has(obj, 'callee');
    };
  }

  // Optimize `isFunction` if appropriate. Work around an IE 11 bug (#1621).
  // Work around a Safari 8 bug (#1929)
  if (typeof /./ != 'function' && typeof Int8Array != 'object') {
    _.isFunction = function(obj) {
      return typeof obj == 'function' || false;
    };
  }

  // Is a given object a finite number?
  _.isFinite = function(obj) {
    return isFinite(obj) && !isNaN(parseFloat(obj));
  };

  // Is the given value `NaN`? (NaN is the only number which does not equal itself).
  _.isNaN = function(obj) {
    return _.isNumber(obj) && obj !== +obj;
  };

  // Is a given value a boolean?
  _.isBoolean = function(obj) {
    return obj === true || obj === false || toString.call(obj) === '[object Boolean]';
  };

  // Is a given value equal to null?
  _.isNull = function(obj) {
    return obj === null;
  };

  // Is a given variable undefined?
  _.isUndefined = function(obj) {
    return obj === void 0;
  };

  // Shortcut function for checking if an object has a given property directly
  // on itself (in other words, not on a prototype).
  _.has = function(obj, key) {
    return obj != null && hasOwnProperty.call(obj, key);
  };

  // Utility Functions
  // -----------------

  // Run Underscore.js in *noConflict* mode, returning the `_` variable to its
  // previous owner. Returns a reference to the Underscore object.
  _.noConflict = function() {
    root._ = previousUnderscore;
    return this;
  };

  // Keep the identity function around for default iteratees.
  _.identity = function(value) {
    return value;
  };

  // Predicate-generating functions. Often useful outside of Underscore.
  _.constant = function(value) {
    return function() {
      return value;
    };
  };

  _.noop = function(){};

  _.property = function(key) {
    return function(obj) {
      return obj == null ? void 0 : obj[key];
    };
  };

  // Generates a function for a given object that returns a given property (including those of ancestors)
  _.propertyOf = function(obj) {
    return obj == null ? function(){} : function(key) {
      return obj[key];
    };
  };

  // Returns a predicate for checking whether an object has a given set of `key:value` pairs.
  _.matches = function(attrs) {
    var pairs = _.pairs(attrs), length = pairs.length;
    return function(obj) {
      if (obj == null) return !length;
      obj = new Object(obj);
      for (var i = 0; i < length; i++) {
        var pair = pairs[i], key = pair[0];
        if (pair[1] !== obj[key] || !(key in obj)) return false;
      }
      return true;
    };
  };

  // Run a function **n** times.
  _.times = function(n, iteratee, context) {
    var accum = Array(Math.max(0, n));
    iteratee = optimizeCb(iteratee, context, 1);
    for (var i = 0; i < n; i++) accum[i] = iteratee(i);
    return accum;
  };

  // Return a random integer between min and max (inclusive).
  _.random = function(min, max) {
    if (max == null) {
      max = min;
      min = 0;
    }
    return min + Math.floor(Math.random() * (max - min + 1));
  };

  // A (possibly faster) way to get the current timestamp as an integer.
  _.now = Date.now || function() {
    return new Date().getTime();
  };

   // List of HTML entities for escaping.
  var escapeMap = {
    '&': '&amp;',
    '<': '&lt;',
    '>': '&gt;',
    '"': '&quot;',
    "'": '&#x27;',
    '`': '&#x60;'
  };
  var unescapeMap = _.invert(escapeMap);

  // Functions for escaping and unescaping strings to/from HTML interpolation.
  var createEscaper = function(map) {
    var escaper = function(match) {
      return map[match];
    };
    // Regexes for identifying a key that needs to be escaped
    var source = '(?:' + _.keys(map).join('|') + ')';
    var testRegexp = RegExp(source);
    var replaceRegexp = RegExp(source, 'g');
    return function(string) {
      string = string == null ? '' : '' + string;
      return testRegexp.test(string) ? string.replace(replaceRegexp, escaper) : string;
    };
  };
  _.escape = createEscaper(escapeMap);
  _.unescape = createEscaper(unescapeMap);

  // If the value of the named `property` is a function then invoke it with the
  // `object` as context; otherwise, return it.
  _.result = function(object, property, fallback) {
    var value = object == null ? void 0 : object[property];
    if (value === void 0) {
      value = fallback;
    }
    return _.isFunction(value) ? value.call(object) : value;
  };

  // Generate a unique integer id (unique within the entire client session).
  // Useful for temporary DOM ids.
  var idCounter = 0;
  _.uniqueId = function(prefix) {
    var id = ++idCounter + '';
    return prefix ? prefix + id : id;
  };

  // By default, Underscore uses ERB-style template delimiters, change the
  // following template settings to use alternative delimiters.
  _.templateSettings = {
    evaluate    : /<%([\s\S]+?)%>/g,
    interpolate : /<%=([\s\S]+?)%>/g,
    escape      : /<%-([\s\S]+?)%>/g
  };

  // When customizing `templateSettings`, if you don't want to define an
  // interpolation, evaluation or escaping regex, we need one that is
  // guaranteed not to match.
  var noMatch = /(.)^/;

  // Certain characters need to be escaped so that they can be put into a
  // string literal.
  var escapes = {
    "'":      "'",
    '\\':     '\\',
    '\r':     'r',
    '\n':     'n',
    '\u2028': 'u2028',
    '\u2029': 'u2029'
  };

  var escaper = /\\|'|\r|\n|\u2028|\u2029/g;

  var escapeChar = function(match) {
    return '\\' + escapes[match];
  };

  // JavaScript micro-templating, similar to John Resig's implementation.
  // Underscore templating handles arbitrary delimiters, preserves whitespace,
  // and correctly escapes quotes within interpolated code.
  // NB: `oldSettings` only exists for backwards compatibility.
  _.template = function(text, settings, oldSettings) {
    if (!settings && oldSettings) settings = oldSettings;
    settings = _.defaults({}, settings, _.templateSettings);

    // Combine delimiters into one regular expression via alternation.
    var matcher = RegExp([
      (settings.escape || noMatch).source,
      (settings.interpolate || noMatch).source,
      (settings.evaluate || noMatch).source
    ].join('|') + '|$', 'g');

    // Compile the template source, escaping string literals appropriately.
    var index = 0;
    var source = "__p+='";
    text.replace(matcher, function(match, escape, interpolate, evaluate, offset) {
      source += text.slice(index, offset).replace(escaper, escapeChar);
      index = offset + match.length;

      if (escape) {
        source += "'+\n((__t=(" + escape + "))==null?'':_.escape(__t))+\n'";
      } else if (interpolate) {
        source += "'+\n((__t=(" + interpolate + "))==null?'':__t)+\n'";
      } else if (evaluate) {
        source += "';\n" + evaluate + "\n__p+='";
      }

      // Adobe VMs need the match returned to produce the correct offest.
      return match;
    });
    source += "';\n";

    // If a variable is not specified, place data values in local scope.
    if (!settings.variable) source = 'with(obj||{}){\n' + source + '}\n';

    source = "var __t,__p='',__j=Array.prototype.join," +
      "print=function(){__p+=__j.call(arguments,'');};\n" +
      source + 'return __p;\n';

    try {
      var render = new Function(settings.variable || 'obj', '_', source);
    } catch (e) {
      e.source = source;
      throw e;
    }

    var template = function(data) {
      return render.call(this, data, _);
    };

    // Provide the compiled source as a convenience for precompilation.
    var argument = settings.variable || 'obj';
    template.source = 'function(' + argument + '){\n' + source + '}';

    return template;
  };

  // Add a "chain" function. Start chaining a wrapped Underscore object.
  _.chain = function(obj) {
    var instance = _(obj);
    instance._chain = true;
    return instance;
  };

  // OOP
  // ---------------
  // If Underscore is called as a function, it returns a wrapped object that
  // can be used OO-style. This wrapper holds altered versions of all the
  // underscore functions. Wrapped objects may be chained.

  // Helper function to continue chaining intermediate results.
  var result = function(instance, obj) {
    return instance._chain ? _(obj).chain() : obj;
  };

  // Add your own custom functions to the Underscore object.
  _.mixin = function(obj) {
    _.each(_.functions(obj), function(name) {
      var func = _[name] = obj[name];
      _.prototype[name] = function() {
        var args = [this._wrapped];
        push.apply(args, arguments);
        return result(this, func.apply(_, args));
      };
    });
  };

  // Add all of the Underscore functions to the wrapper object.
  _.mixin(_);

  // Add all mutator Array functions to the wrapper.
  _.each(['pop', 'push', 'reverse', 'shift', 'sort', 'splice', 'unshift'], function(name) {
    var method = ArrayProto[name];
    _.prototype[name] = function() {
      var obj = this._wrapped;
      method.apply(obj, arguments);
      if ((name === 'shift' || name === 'splice') && obj.length === 0) delete obj[0];
      return result(this, obj);
    };
  });

  // Add all accessor Array functions to the wrapper.
  _.each(['concat', 'join', 'slice'], function(name) {
    var method = ArrayProto[name];
    _.prototype[name] = function() {
      return result(this, method.apply(this._wrapped, arguments));
    };
  });

  // Extracts the result from a wrapped and chained object.
  _.prototype.value = function() {
    return this._wrapped;
  };

  // AMD registration happens at the end for compatibility with AMD loaders
  // that may not enforce next-turn semantics on modules. Even though general
  // practice for AMD registration is to be anonymous, underscore registers
  // as a named module because, like jQuery, it is a base library that is
  // popular enough to be bundled in a third party lib, but not be part of
  // an AMD load request. Those cases could generate an error when an
  // anonymous define() is called outside of a loader request.
  if (typeof define === 'function' && define.amd) {
    define('underscore', [], function() {
      return _;
    });
  }
}.call(this));

});
define("mod-util/0.3.0/src/data-api-debug", ["jquery"], function(require, exports, module){
/**
 * Created by Harris on 14/12/25.
 */
'use strict';
var $ = require("jquery");
var _did = 1,
    __this = {},
    isString = function(v){return typeof v == 'string'},
    slice = Array.prototype.slice,
    isArray = Array.isArray,
    $root = $('body');
var isDefaultOff = $root.data('api') === 'off',camelize = $.camelCase;
var delegateEvents = function(handler,eventName,parentsNode,data){
    if(arguments.length === 1){
        eventName = 'click',
        parentsNode = 'body',
        data = [];
    }else if(arguments.length == 2){
        parentsNode = 'body',
        data = []
    }else if(arguments.length === 3){
        if(isString(parentsNode)){
            data = [];
        }else if($.isPlainObject(parentsNode) || isArray(parentsNode)){
            data = parentsNode,parentsNode = 'body'
        }else{
            parentsNode = 'body',data = [];
        }
    }
    if($.trim(parentsNode) == ''){
        parentsNode = 'body';
    }
    if(!isDataApiOn(parentsNode)){
        return ;
    }
    var $node = $(parentsNode),
        targetName = eventName === 'click' ? 'event' : 'event-' + eventName,
        target = "[data-" + targetName + "]";
    __d($node);
    $node.on(eventName.replace(/-/g,'.'),target,data,function(){
        var id = did(this),
            $this = __this[id] || (__this[id] = $(this)),
            ev = $this.data(camelize(targetName));
        __d($node,id,$this,ev);
        try{
            handler[ev] && handler[ev].apply($this,slice.call(arguments,0));
        }catch(ex){
            __d(ex);
        }
    })
}
exports.delegateEvents = delegateEvents;
var autoInit = function(initHandler,resizeHandler,context){
    var $ctx = context || $('body');
    if(initHandler){
        var $init = $ctx.find('[data-init]');
        $init.each(function(i,item){
            var $item = $(item),
                ev = $item.data('init');
            __d($item,ev,i,item);
            if(isDataApiOn($item)){
                try{
                    initHandler[ev] && initHandler[ev].call($item)
                }catch(ex){}
            }
        });
    }
    if(resizeHandler){
        resizeHandler.__timer = null;
        $(window).resize(function(){
            resizeHandler.__timer && clearTimeout(resizeHandler.__timer);
            resizeHandler.__timer = setTimeout(function(){
                var $resize = $ctx.find('[data-resize]');
                $resize.each(function(i,item){
                    var $item = $(item),
                        ev = $item.data('resize');
                    __d($item,ev,i,item);
                    if(isDataApiOn($item)){
                        try{
                            resizeHandler[ev] && resizeHandler[ev].call($item)
                        }catch(ex){}
                    }
                })
            },80);

        })
    }

}
exports.autoInit = autoInit;
function did(el){
    return el._did || (el._did = _did++);
}
function isDataApiOn(element){
    var $e = $(element),
        _api = $e.data('api'),
        ret = (_api === 'on' || (_api !== 'off' && !isDefaultOff));
    __d(ret,isDefaultOff);
    return ret;
}
exports.isDataApiOn = isDataApiOn;
function __d(){
    if(exports.debug)
        console.log.apply(console,slice.call(arguments,0));
}
function _destroy(o){
    for(var k in o){
        if(o.hasOwnProperty(k)){
            delete o[k];
        }
    }
    return o = null;
}
function destroy(){
    __d(__this);
    _destroy(__this);
}
exports.destroy = destroy;
});
define("mod-util/0.3.0/src/platform-debug", [], function(require, exports, module){
/**
 * Created by Harris on 15/1/6.
 */

var format = function(ua){
    ua = ua.toLowerCase();
    var os = {},browser = os.browser = {},app = browser.app = {};
    var webkit = ua.match(/webkit[\/]{0,1}([\d.]+)/),
        android = ua.match(/(android);?[\s\/]+([\d.]+)?/),
        osx = !!ua.match(/\(Macintosh\; Intel/),
        ios = ua.match(/(iphone|ipod|ipad)(.*os\s([\d_]+))?/),
        wp = ua.match(/windows phone ([\d.]+)/),
        chrome = ua.match(/chrome\/([\d.]+)/),
        firefox = ua.match(/Firefox\/([\d.]+)/),
        linux = ua.match(/linux/);
    var isWeiChat = ua.match(/micromessenger[\s\/]+([\d.a-z_]+)?/),
        isWeiBo = ua.match(/weibo([\s\S\/].*weibo__([\d.]+))?/)
    if(android){
        os.android = true;
        os.version = android[2];
    }
    if(ios){
        os.ios = true;
        os.version = ios[3];
        os.platform = ios[1];
    }
    if(webkit){
        browser.webkit = !!webkit;
        browser.version = webkit[1];
    }
    if(chrome){
        app.name = 'chrome';
        app.version = chrome[1];
    }
    if(firefox){
        app.name = 'firefox';
        app.version = firefox[1];
    }
    if(linux){
        os.linux = !!linux;
    }
    if(wp){
        os.wp = true;
        os.version = wp[1];
    }
    if(isWeiChat){
        app.name = 'weiChat';
        app.version = isWeiChat[1];
    }
    if(isWeiBo){
        app.name = 'weibo';
        app.version = isWeiBo[2];
    }
    if(os.version){
       os.version = parseFloat(os.version.split(/\.|\_/).join('.'));
    }
    return os;
}
exports.format = format;
exports.OS = format(window.navigator.userAgent);
});
define("mod-util/0.3.0/src/style-debug", [], function(require, exports, module){
/**
 * Created by Harris on 15/1/11.
 */
var platformPrefix = "-webkit- -o- -moz- ".split(" ");
var needPrefixItems = "animation transform transition keyframes".split(" ");
var tool = require("mod-util/0.3.0/src/tool-debug"),
    _ = tool._,
    needRegExp = new RegExp(needPrefixItems.join('|'));
var prefix = function(k,v){
    var i,len = platformPrefix.length,ret = [];
    if(needRegExp.test(k.toLowerCase())){
        for(i = 0;i<len;i++){
            var tmp = platformPrefix[i];
            ret.push(styleCreator.cssItem(tmp +k,v))
        }
    }else{
        ret.push(styleCreator.cssItem(k,v));
    }
    return ret.join('');
}
var styleCreator = {
    'keyframes':function(name,val){
        var keyframe = '@{{pft}}keyframes ' + name + ' { {{code}} }',i,len=platformPrefix.length,tmp = [],ret = [],_self = this;
        _.each(val,function(v,k){
            tmp.push(_self.css(k,v))
        });
        for(i = 0;i < len;i++){
            ret.push(keyframe.replace(/\{\{pft\}\}/,platformPrefix[i]).replace(/\{\{code\}\}/,tmp.join(' ')));
        }
        return ret.join(' ');
    },
    'css':function(name,cnt,dot){
        var css = (dot ? '.':'') + name +"{ {{css}} }",ret = [];
        if(typeof cnt === 'string'){
            ret.push(cnt);
        }else if(_.isObject(cnt)){
            _.each(cnt,function(v,k){
                ret.push(prefix(k,v));
            })
        }
        return css.replace(/\{\{css\}\}/,ret.join(' '))
    },
    'cssItem':function(k,v){
        return k + ':' + v + ';';
    },
    create:function(style){
        if(!_.isObject(style)){
            throw new Error('arguments type error!');
        }
        var css = [],keyframes = style['keyframes'],_self = this;
        keyframes && (delete  style['keyframes']);
        if(keyframes){
            _.each(keyframes,function(v,k){
                css.push(_self.keyframes(k,v));
            });
        }
        _.each(style,function(v,k){
            css.push(_self.css(k,v,true))
        });
        var _s = document.createElement('style');
        _s.innerHTML = css.join(' ');
        document.getElementsByTagName('head')[0].appendChild(_s);
        return _s;
    }
};
module.exports = styleCreator;
module.exports.prefixedCSS = prefix;
});
define("mod-util/0.3.0/src/handlebarsHelper-debug", [], function(require, exports, module){
/**
 * Created by Harris on 15/1/20.
 */
var tool = require("mod-util/0.3.0/src/tool-debug"),
    _ = tool._;
var Helpers = {
    'compare': function (v1, opt, v2, options) {
        if (opt === '==' && v1 == v2) {
            return options.fn(this);
        }else if (opt === '<' && v1 < v2) {
            return options.fn(this);
        }else if (opt === '>' && v1 > v2) {
            return options.fn(this);
        }else{
            return options.inverse(this);
        }
    },
    'lcs_format_time':function(time,sys){
        return tool.lcs.timeFormat(time,sys);
    },
    'round':function(num){
        var _ret = Math.round(parseFloat(num));
        if(isNaN(_ret) || _ret == "NaN"){
            return 0;
        }
        return _ret;
    }
}
module.exports = function(HBS){
    if(_.isFunction(HBS.registerHelper)){
        _.each(Helpers,function(helper,name){
            HBS.registerHelper(name,helper);
        })
    }
}
});
